#include <sstream>
#include <iomanip>
#include <string>
#include <iostream>
#include <ostream>


template<class T>
std::string Value2String(T value)
{
	string result;
	std::stringstream ss;
	ss << value;
	ss >> result;
	return result;
}

template<class T>
T String2Value(const std::string &s)
{
	T result;
	std::stringstream ss(s);
	ss >> result;
	return result;
}

template<class T>
T String2HexValue(const std::string &s)
{
	T result;
	std::stringstream ss;
	ss << std::hex << s;
	ss >> (hex) >> result;
	return result;
}

template<class T>
std::string to_string(const T& thing) {
	std::ostringstream ss;
	ss << thing;
	return ss.str();
}

template <class T>
bool from_string(T& t, 
                 const std::string& s, 
                 std::ios_base& (*f)(std::ios_base&))
{
  std::istringstream iss(s);
  return !(iss >> f >> t).fail();
}
